# render and compose

## project description

This project has two modules, renderer and compositor:
- renderer: render views of a 3d model from various perspectives
- compositor: compose images by pasting the rendered views on some background images

The modules can be used to generate templates for template matching methods such as LINEMOD, and to compose training images for Deep Learning methods for object detection (either 2d bounding box detection or 6d pose estimation).

## installation

I used python 3.6 with pyrender and opencv. Would be nice to have a full list of dependencies here.

Also, I aim for providing this module as docker image - so probably I will have the dependencies list in near future (and you have the additional option to avoid installation and simply use the docker container).

## how to use

A simple example to get started is provided along with all required files such as model and background images (see the `examples` folder). Simply running the `render_and_compose.py` without any arguments will run this example.

For your own use, you will need to create a config file (similar to `examples/example.cfg`) and pass it as argument. The config file specifies everything: directories where to put the generated data, rendering options such as how to generate different camera poses, and compositing options. Note that the available parameters are described in `examples/example.cfg`, so I recommend to use that config file as a template.

Furthermore, you could be interested in some useful datasets, e.g. models for the renderer or background images for the compositor. I recommend the following:

- models
	- ABC: https://deep-geometry.github.io/abc-dataset/
- background images
	- COCO: http://cocodataset.org/
	- Pascal VOC: http://host.robots.ox.ac.uk/pascal/VOC/
	- ImageNet: http://www.image-net.org/

## renderer

This module uses a specified 3d model and generates object images, which can be used as templates or for compositing. There are two strategies available for generating different camera poses: `RandomCameraPoseGenerator` and `IcoSphereCameraPoseGenerator`.

![162 random poses](./images/random_162.png)
![162 poses on an icosphere](./images/icosphere.gif)

The renderer creates color images and binary masks. Depth images are planned. (Need to figure out how to save the depth images, as they are floating point values in meters and result in a [0,1] mask-like image when saving as png.)

Currently, illumination is a single SpotLight at the same pose as the camera. To have more variance here, I want to enable using ambient light and several randomly placed SpotLights with some random light color.

A ground truth file is created in the target directory, with all rendering settings and a complete list of objects and corresponding filenames and poses.


## compositor

The compositor module uses views generated by the renderer (i.e. it relies on the generated ground truth file). It places these views at random positions onto random background images chosen from the provided directory. You can configure how many objects there shall be per image, and how often you want to reuse each object view.

Further work is required to compose the ground truth file (with adjustment of position information). Also adding some distractor objects would be great, this might leverage training neural networks for object detection.

![sample composite](./images/composite.png)

